<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>TestingCardsLotDataSource</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/operation/testing-cards-lot/testing-cards-lot-list/testing-cards-lot-list.component.ts</code>
        </p>


            <p class="comment">
                <h3>Extends</h3>
            </p>
            <p class="comment">
                    <code>DataSource</code>
            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                <a href="#disconnect">disconnect</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(data: <a href="../classes/TestingCardsLot.html">BehaviorSubject<TestingCardsLot[]></a>, sort: MatSort, translateService: TranslateService)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="114" class="link-to-prism">src/app/operation/testing-cards-lot/testing-cards-lot-list/testing-cards-lot-list.component.ts:114</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>data</td>
                                                  
                                                        <td>
                                                                    <code><a href="../classes/TestingCardsLot.html" target="_self" >BehaviorSubject&lt;TestingCardsLot[]&gt;</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>sort</td>
                                                  
                                                        <td>
                                                                    <code>MatSort</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>translateService</td>
                                                  
                                                        <td>
                                                                    <code>TranslateService</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>


            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="connect"></a>
                        <span class="name">
                            <b>
                            connect
                            </b>
                            <a href="#connect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>connect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="121" class="link-to-prism">src/app/operation/testing-cards-lot/testing-cards-lot-list/testing-cards-lot-list.component.ts:121</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;any[]&gt;</code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="disconnect"></a>
                        <span class="name">
                            <b>
                            disconnect
                            </b>
                            <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>disconnect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="138" class="link-to-prism">src/app/operation/testing-cards-lot/testing-cards-lot-list/testing-cards-lot-list.component.ts:138</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnDestroy, OnInit, ViewChild } from &#x27;@angular/core&#x27;;
import { ActivatedRoute, Router } from &#x27;@angular/router&#x27;;
import { TranslateService } from &#x27;@ngx-translate/core&#x27;;
import { DataSource } from &#x27;@angular/cdk/collections&#x27;;
import { MatSort } from &quot;@angular/material/sort&quot;;
import { BehaviorSubject } from &#x27;rxjs/BehaviorSubject&#x27;;
import { Observable } from &#x27;rxjs/Observable&#x27;;
import { TdDialogService } from &#x27;@covalent/core&#x27;;
import { sortOnProperty } from &#x27;../../../core/util/table-utils&#x27;;
import { OperationManagementService } from &#x27;../../service/operation-managment.service&#x27;;
import { Subscription } from &#x27;rxjs/Subscription&#x27;;
import { map } from &#x27;rxjs/operators&#x27;;
import { merge } from &#x27;rxjs/observable/merge&#x27;;
import { TestingCardsLot } from &#x27;../model/testing-cards-lot&#x27;;
import { TestingCardsLotService } from &#x27;../service/testing-cards-lot.service&#x27;;
import { ReadOnlyService } from &#x27;../../service/read-only.service&#x27;;
import { OperationDataService } from &#x27;../../service/operation.data.service&#x27;;
import { DomainOfInfluence } from &#x27;../../../model/domain-of-Influence.model&#x27;;

@Component({
  selector: &#x27;testing-cards-lot-list&#x27;,
  templateUrl: &#x27;./testing-cards-lot-list.component.html&#x27;,
  styleUrls: [&#x27;./testing-cards-lot-list.component.scss&#x27;]
})
export class TestingCardsLotListComponent implements OnInit, OnDestroy {

  testingCardsLotSubject &#x3D; new BehaviorSubject&lt;TestingCardsLot[]&gt;([]);

  dataSource;

  subscriptions: Subscription[] &#x3D; [];

  @ViewChild(MatSort) sort: MatSort;
  relatedDoi: DomainOfInfluence[];

  constructor(private route: ActivatedRoute,
              private translateService: TranslateService,
              private testingCardsLotService: TestingCardsLotService,
              private operationDataService: OperationDataService,
              private operationManagementService: OperationManagementService,
              private dialogService: TdDialogService,
              private readOnlyService: ReadOnlyService,
              private router: Router) {
  }

  private _readOnly: boolean;

  get readOnly() {
    return this._readOnly;
  }

  get displayedColumns(): string[] {
    return [&quot;lotName&quot;, &quot;cardType&quot;, &quot;count&quot;, &quot;voter&quot;, &quot;language&quot;, &quot;shouldPrint&quot;, &quot;actions&quot;];

  }

  get elementsCount() {
    return this.testingCardsLotSubject.value.length;
  }

  get forConfiguration() {
    return !!this.route.snapshot.data.forConfiguration;
  }

  ngOnInit() {
    this.dataSource &#x3D;
      new TestingCardsLotDataSource(this.testingCardsLotSubject, this.sort, this.translateService);


    this.subscriptions.push(
      this.readOnlyService.isTestingCardInReadOnly(this.forConfiguration)
        .subscribe(readOnly &#x3D;&gt; this._readOnly &#x3D; readOnly),
      this.operationManagementService.operation.subscribe(operation &#x3D;&gt; {
        this.testingCardsLotService.findAll(operation.id, this.forConfiguration)
          .subscribe(data &#x3D;&gt; this.testingCardsLotSubject.next(data));
        this.operationDataService.getAllRelatedDois(operation.id).subscribe(
          dois &#x3D;&gt; this.relatedDoi &#x3D; dois.filter(doi &#x3D;&gt; doi.type !&#x3D;&#x3D; &quot;Unknown&quot;));


      })
    )
  }

  ngOnDestroy(): void {
    this.subscriptions.forEach(s &#x3D;&gt; s.unsubscribe());
  }

  createNew() {
    this.router.navigate([&#x27;create&#x27;], {relativeTo: this.route});
  }

  remove(element: TestingCardsLot) {
    this.dialogService.openConfirm({
      message: this.translateService.instant(&#x27;testing-cards-lot.dialogs.delete&#x27;, element),
      disableClose: true,
      cancelButton: this.translateService.instant(&#x27;global.actions.no&#x27;),
      acceptButton: this.translateService.instant(&#x27;global.actions.yes&#x27;),
    }).afterClosed().subscribe((accept: boolean) &#x3D;&gt; {
      if (accept) {
        this.testingCardsLotService.remove(element.id)
          .subscribe(() &#x3D;&gt; this.testingCardsLotSubject.next(
            this.testingCardsLotSubject.getValue().filter((e) &#x3D;&gt; e.id !&#x3D; element.id)));
      }
    });
  }

  edit(element: TestingCardsLot) {
    this.router.navigate([element.id], {relativeTo: this.route});
  }

}


class TestingCardsLotDataSource extends DataSource&lt;any&gt; {

  constructor(private data: BehaviorSubject&lt;TestingCardsLot[]&gt;, private sort: MatSort,
              private translateService: TranslateService) {
    super();
  }

  connect(): Observable&lt;any[]&gt; {
    return merge(this.data, this.sort.sortChange)
      .pipe(
        map(() &#x3D;&gt; this.data.getValue().map(
          lot &#x3D;&gt; Object.assign({}, lot, {
            cardType: this.translateService.instant(&#x60;dictionary.card-type.${lot.cardType}&#x60;),
            signature: this.translateService.instant(&#x60;dictionary.signature.${lot.signature}&#x60;),
            shouldPrint: this.translateService.instant(
              &#x60;testing-cards-lot.form.values.should-print.${lot.shouldPrint}&#x60;),
            address: [lot.address1, lot.address2, lot.street, &#x60;${lot.postalCode} ${lot.city} ${lot.country}&#x60;].filter(
              v &#x3D;&gt; !!v)

          })
        )),
        map(translated &#x3D;&gt; sortOnProperty(translated, this.sort.active, this.sort.direction)));
  }

  disconnect() {
  }
}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'TestingCardsLotDataSource.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
